<?php
# main
if(!isset($_SESSION)) session_start();
include_once('guestbookGS/captcha.php');

# get correct id for plugin
$thisfile = basename(__FILE__, ".php");
define('GUEST_BOOK', 'guestbookGS.xml');
define('GUEST_CONF', 'guestconf.xml');
define('DATA_PATH', '../plugins/guestbookGS/data/');
define('PAGE_PATH', 'plugins/guestbookGS/data/');
define('CSS_STYLE', 'plugins/guestbookGS/css/gstbook.css');
define('CSS_ADMIN', 'plugins/guestbookGS/css/guestbook_admin.css');
define('NIC_EDIT', 'plugins/guestbookGS/js/nicEdit_byopiums.js');

# register plugin
register_plugin(
	$thisfile, 
	'guestbookGS', 	
	'2.0.3', 		
	'opiums',
	'http://opiums.eu', 
	'Гостевая книга с предварительной модерацией отзывов (декабрь 2020).',
	'theme',
	'moderation'  //moderation function in admin panel
);

# register and add css-style to backend
register_style('guestbook_css', $SITEURL.CSS_ADMIN , date('y.m'),  'screen');
queue_style('guestbook_css', GSBACK);

#i18n compatible language
i18n_merge('guestbookGS', $LANG) || i18n_merge('guestbookGS','en_US'); 

# add link in admin sidebar 
add_action('theme-sidebar', 'createSideMenu', array($thisfile, i18n_r('guestbookGS/MODERATION_LINK')));

# add css to front-end
add_action('theme-header', 'include_css');

# functions
function include_css(){
	global $SITEURL;
  	echo PHP_EOL .'<link rel="stylesheet" href="', $SITEURL, CSS_STYLE, '" media="screen" type="text/css"/>';
}

#conf
function gsb_config($path_conf){
	if(file_exists($path_conf)){
		$oxml = simplexml_load_file($path_conf);
		if($oxml){
			$nicEdit = $oxml->nicEdit; //Использовать nicEdit
			$gsb_send = $oxml->gsb_send; //Уведомление по email если написали сообщение
			$gsb_date =$oxml->gsb_date; //Показывать дату
			$gsb_to = $oxml->gsb_to; //На какой email слать оповещения
			$gsb_from = '<'.$oxml->gsb_from.'>'; //От кого отправлять оповещения
			$gsb_sort = $oxml->gsb_sort; //Использовать обратную сортировку
			$gsb_item = $oxml->gsb_item; //Кол-во отзывов на страницу
			return array(
					'nicEdit' => (string)$nicEdit,
					'gsb_send' => (string)$gsb_send,
					'gsb_date' => (string)$gsb_date,
					'gsb_to' => (string)$gsb_to,
					'gsb_from' => (string)$gsb_from,
					'gsb_sort' => (string)$gsb_sort,
					'gsb_item' => (string)$gsb_item
				);
		}else echo '<div class="updated"><p>Некорректная конфигурация!</p></div>';
	}else{
		$dom_conf = new DOMDocument("1.0", "UTF-8");
		$option = $dom_conf->appendChild($dom_conf->createElement('option'));
		
		$_nicEdit = $option->appendChild($dom_conf->createElement('nicEdit'));
		$_gsb_send = $option->appendChild($dom_conf->createElement('gsb_send'));
		$_gsb_date = $option->appendChild($dom_conf->createElement('gsb_date'));
		$_gsb_to = $option->appendChild($dom_conf->createElement('gsb_to'));
		$_gsb_from = $option->appendChild($dom_conf->createElement('gsb_from'));
		$_gsb_sort = $option->appendChild($dom_conf->createElement('gsb_sort'));
		$_gsb_item = $option->appendChild($dom_conf->createElement('gsb_item'));
		
		$_nicEdit->appendChild($dom_conf->createTextNode('true'));
		$_gsb_send->appendChild($dom_conf->createTextNode('true'));
		$_gsb_date->appendChild($dom_conf->createTextNode('true'));
		$_gsb_to->appendChild($dom_conf->createTextNode('info@'.$_SERVER['HTTP_HOST']));
		$_gsb_from->appendChild($dom_conf->createTextNode('admin@'.$_SERVER['HTTP_HOST']));
		$_gsb_sort->appendChild($dom_conf->createTextNode('true'));
		$_gsb_item->appendChild($dom_conf->createTextNode('10'));
		
		$dom_conf->formatOutput = true;
		$dom_conf->saveXML();
		$dom_conf->save($path_conf);
		echo '<div class="updated"><p>Файл конфигурации создан с нуля!</p></div>';
	}
}

function moderation(){
	//i18n compatible language
	global $i18n;
	$conf = gsb_config(DATA_PATH.GUEST_CONF);
	i18n_merge('guestbookGS') || i18n_merge('guestbookGS','en_US');
	if(isset($_POST['vis'])){  //обработка отзыва в true (treatment reviews to true)
		$dtm = (string)trim(strip_tags($_POST['dtm']));
		if(file_exists(DATA_PATH.GUEST_BOOK)){
			$vxml = simplexml_load_file(DATA_PATH.GUEST_BOOK);
			if($vxml){
				foreach($vxml->record as $record){
					if($record->dtm == $dtm){
						$record->visibility = 'true';
					}
				}
				$vxml->asXML(DATA_PATH.GUEST_BOOK);
				unset($vxml);
			}else echo i18n("guestbookGS/XML_FORMAT_FILED");
		}else echo i18n("guestbookGS/XML_READ_FILED");
		unset($dtm);
	}
	if(isset($_POST['invis'])){  //обработка отзыва в false (treatment reviews to false)
		$dtm = (string)trim(strip_tags($_POST['dtm']));
		if(file_exists(DATA_PATH.GUEST_BOOK)){
			$vxml = simplexml_load_file(DATA_PATH.GUEST_BOOK);
			if($vxml){
				foreach($vxml->record as $record){ 
					if($record->dtm == $dtm){
						$record->visibility = 'false';
					}
				}
				$vxml->asXML(DATA_PATH.GUEST_BOOK);
				unset($vxml);
			}else echo i18n("guestbookGS/XML_FORMAT_FILED");
		}else echo i18n("guestbookGS/XML_READ_FILED");
		unset($dtm);
	}
	if(isset($_POST['delete'])){  //удаление отзыва (removal of a review)
		$dtm = (string)trim(strip_tags($_POST['dtm']));
		if(file_exists(DATA_PATH.GUEST_BOOK)){
			$vxml = simplexml_load_file(DATA_PATH.GUEST_BOOK);
			if($vxml){
				$cnt = 0;
				foreach($vxml->record as $record){
					if($record->dtm == $dtm){
						//echo $cnt;
						break;
					}
					$cnt++;
				}
				unset($vxml->record[(int)$cnt]);
				$vxml->asXML(DATA_PATH.GUEST_BOOK);
				unset ($cnt);
			}else echo i18n("guestbookGS/XML_FORMAT_FILED");
			unset($vxml);
		}else echo i18n("guestbookGS/XML_READ_FILED");
		unset($dtm);
	}
	if(isset($_POST['edit'])){  //редактирование отзыва (edit review)
		$dtm = (string)trim(strip_tags($_POST['dtm']));
		if(file_exists(DATA_PATH.GUEST_BOOK)){
			$vxml = simplexml_load_file(DATA_PATH.GUEST_BOOK);
			if($vxml){
				$cnt = 0;
				foreach($vxml->record as $record){
					if($record->dtm == $dtm){
						break;
					}
					$cnt++;
				}
				echo '<div class="gsb">';
				echo '<form action="" method="post" class="cont1">';
				if($conf['nicEdit'] == 'true'){
					echo '<style>.cont1 div,.cont img{max-width:100%;}</style>';
					echo '<script type="text/javascript" src="/'.NIC_EDIT.'"></script>';
					echo '<script type="text/javascript">bkLib.onDomLoaded(function(){nicEditors.allTextAreas({fullPanel:true})});</script>';
				}
				$gsbi_rat = '';
				for($gsbi = 1; $gsbi <= 5; $gsbi++){
					if($gsbi == $vxml->record[(int)$cnt]->rating) $gsbi_rat .= '<option selected value="'.$gsbi.'">Оценка '.$gsbi.' (активно)</option>';
					else $gsbi_rat .= '<option value="'.$gsbi.'">Оценка '.$gsbi.'</option>';
				}
				echo '<p><h1 class="userdata">',i18n("guestbookGS/USER_NAME"),'</h1><input class="inpt" type="text" name="username" value="',$vxml->record[(int)$cnt]->username,'"></p>';
				echo '<p><h1 class="userdata">',i18n("guestbookGS/USER_MAIL"),'</h1><input class="inpt" type="text" name="mail" value="',$vxml->record[(int)$cnt]->mail,'"></p>';
				echo '<p><h1 class="userdata">',i18n("guestbookGS/USER_RATING"),'</h1><select name="rating">',$gsbi_rat,'</select></p>';
				echo '<p><h1 class="userdata">',i18n("guestbookGS/USER_REVIEW"),'</h1><textarea class="inpt2" name="message" style="width:100%;height:400px;">',$vxml->record[(int)$cnt]->message,'</textarea></p>';
				echo '<input name="dtm" type="hidden" value="',$vxml->record[(int)$cnt]->dtm,'">';
				echo '<p><input class="posit" type="submit" name="save" value="',i18n("guestbookGS/SAVE_REVIEW"),'"></p>';
				echo '<p><input class="posit" type="submit" name="return" value="',i18n("guestbookGS/RETURN_REVIEW"),'"></p></form>';
				echo '<hr class="clrb">';
				echo '</div>';
				exit;
			}else echo i18n("guestbookGS/XML_FORMAT_FILED");
		}else echo i18n("guestbookGS/XML_READ_FILED");
		unset($dtm);
	}
	if(isset($_POST['save'])){  //сохранение отмодерированного отзыва (the preservation of moderated review)
		$dtm = (string)trim(strip_tags($_POST['dtm']));
		$username = (string)trim(strip_tags($_POST['username']));
		$mail = (string)trim(strip_tags($_POST['mail']));
		$message = (string)trim(escapeStr($_POST['message']));
		$rating = (isset($_POST['rating'])) ? (int)$_POST['rating'] : 0;
		if(file_exists(DATA_PATH.GUEST_BOOK)){
			$vxml = simplexml_load_file(DATA_PATH.GUEST_BOOK);
			if($vxml){
				foreach($vxml->record as $record){
					if($record->dtm == $dtm){
						$record->username = $username;
						$record->mail = $mail;
						$record->message = $message;
						$record->rating = $rating;
					}
				}
				$vxml->asXML(DATA_PATH.GUEST_BOOK);
				unset($vxml);
				unset($cnt);
			}
		}
	}
	if(isset($_POST['conf'])){  //сохранение конфигурации (save config)
		$nicEdit_save = (string)trim(strip_tags($_POST['nicEdit']));
		$gsb_send_save = (string)trim(strip_tags($_POST['gsb_send']));
		$gsb_date_save = (string)trim(strip_tags($_POST['gsb_date']));
		$gsb_to_save = (string)trim(strip_tags($_POST['gsb_to']));
		$gsb_from_save = (string)trim(strip_tags($_POST['gsb_from']));
		$gsb_sort_save = (string)trim(strip_tags($_POST['gsb_sort']));
		$gsb_item_save = (string)trim(strip_tags($_POST['gsb_item']));
		if(file_exists(DATA_PATH.GUEST_CONF)){
			$coxml = simplexml_load_file(DATA_PATH.GUEST_CONF);
			if($coxml){
				$coxml->nicEdit = $nicEdit_save;
				$coxml->gsb_send = $gsb_send_save;
				$coxml->gsb_date = $gsb_date_save;
				$coxml->gsb_to = $gsb_to_save;
				$coxml->gsb_from = $gsb_from_save;
				$coxml->gsb_sort = $gsb_sort_save;
				$coxml->gsb_item = $gsb_item_save;
				//print_r($coxml->asXML());
				//print_r($_POST);
				$coxml->asXML(DATA_PATH.GUEST_CONF);
				unset($coxml);
			}
			echo '<div class="updated"><p>Конфигурация сохранена!</p></div>';
		}else echo '<div class="updated"><p>Файл конфигурации не обнаружен!</p></div>';
	}
	if(file_exists(DATA_PATH.GUEST_BOOK)){  //вывод немодерированных отзывов (the output of the feedback without moderation)
		$nxml = simplexml_load_file(DATA_PATH.GUEST_BOOK);
		$oxml = simplexml_load_file(DATA_PATH.GUEST_CONF);
		if($nxml && $oxml){
			$naxml = array();
			foreach($nxml as $arecord){
				$naxml[] = $arecord;
			}
			/*usort($naxml,function($a,$b){return $a['dtm']-$b['dtm'];});*/
			
			$nxml = ($conf['gsb_sort'] == 'true') ? array_reverse($naxml) : $naxml;
			$nxml_cnt = count($nxml);
			$limit = (int)$conf['gsb_item'];
			$targetpage = $_SERVER['PHP_SELF'].'?id=guestbookGS&';
			
			$page = (isset($_GET['page'])) ? (int)$_GET['page'] : false;
			$start = ($page) ? ($page - 1) * $limit : 0;
			$lastpage = ceil($nxml_cnt/$limit);
			$nxml = array_slice($nxml, $start, $limit);
			
			$cnt = $start;
			echo '<div class="gsb">';
			echo '<button onclick="$(this).next().slideToggle(\'fast\');">Настройки</button>';
			echo '<div style="display:none;"><br>';
			echo '<form action="" method="post">';
			echo '<p><label for="nicEdit">WYSIWYG редактор</label>';
			echo '<select id="nicEdit" name="nicEdit"><option value="',$oxml->nicEdit,'" selected>',$oxml->nicEdit,'</option>';
			echo '<option value="true">true (да)</option><option value="false">false (нет)</option></select></p>';
			echo '<p><label for="gsb_send">Уведомление по email</label>';
			echo '<select id="gsb_send" name="gsb_send"><option value="',$oxml->gsb_send,'" selected>',$oxml->gsb_send,'</option>';
			echo '<option value="true">true (да)</option><option value="false">false (нет)</option></select></p>';
			echo '<p><label for="gsb_date">Показывать дату</label>';
			echo '<select id="gsb_date" name="gsb_date"><option value="',$oxml->gsb_date,'" selected>',$oxml->gsb_date,'</option>';
			echo '<option value="true">true (да)</option><option value="false">false (нет)</option></select></p>';
			echo '<p><label for="gsb_to">На какой email слать оповещения</label>';
			echo '<input type="text" name="gsb_to" value="',$oxml->gsb_to,'"></p>';
			echo '<p><label for="gsb_from">От какого email отправлять оповещения</label>';
			echo '<input type="text" name="gsb_from" value="',$oxml->gsb_from,'"></p>';
			echo '<p><label for="gsb_sort">Использовать обратную сортировку</label>';
			echo '<select id="gsb_sort" name="gsb_sort"><option value="',$oxml->gsb_sort,'" selected>',$oxml->gsb_sort,'</option>';
			echo '<option value="true">true (да)</option><option value="false">false (нет)</option></select></p>';
			echo '<p><label for="gsb_item">Кол-во отзывов на страницу</label>';
			echo '<input type="text" name="gsb_item" value="',$oxml->gsb_item,'"></p>';
			echo '<p><input class="posit" type="submit" name="conf" value="',i18n("guestbookGS/SAVE_CONF"),'"></p>';
			echo '</form>';
			echo '<hr class="clrb">';
			echo '</div>';
			echo '&emsp;<button onclick="window.location=window.location.href;">Обновить страничку</button>';
			echo '<br /><br />';
			foreach($nxml as $record){
				$cnt++;
				echo '<h1 class="message"><b>'.$cnt.'</b>. '.$record->message.'</h1>';
				echo '<h1 class="userdata">',i18n("guestbookGS/USER_NAME"),': ',$record->username,'</h1>';
				echo '<h1 class="userdata">',i18n("guestbookGS/USER_MAIL"),': ',$record->mail,'</h1>';
				echo '<h1 class="userdata">',i18n("guestbookGS/USER_DATE"),': ',date('d-m-Y H:i:s', (int)$record->dtm),'</h1>';
				echo '<h1 class="userdata">',i18n("guestbookGS/USER_RATING"),': ',$record->rating,'</h1>';
				echo "<br>";
				if(strtoupper($record->visibility) == "TRUE"){
					echo '<h1 class="vis">',i18n("guestbookGS/REV_VISIBLE"),'</h1>';
					echo '<br>';
					echo '<form action="" method="post">';
					echo '<input name="dtm" type="hidden" value="',$record->dtm,'">';
					echo '<input class="posit" type="submit" name="invis" value="',i18n("guestbookGS/MADE_INVISIBLE"),'"></form>';
				}else{
					echo '<h1 class="invis">',i18n("guestbookGS/REV_INVISIBLE"),'</h1>';
					echo '<br>';
					echo '<form action="" method="post">';
					echo '<input name="dtm" type="hidden" value="',$record->dtm,'">';
					echo '<input class="posit" type="submit" name="vis" value="',i18n("guestbookGS/MADE_VISIBLE"),'"></form>';
				}
				echo '<form action="" method="post">';
				echo '<input name="dtm" type="hidden" value="',$record->dtm,'">';
				echo '<input class="posit" type="submit" name="delete" value="',i18n("guestbookGS/REMOVE_COMMENT"),'"></form>';
				echo '<form action="" method="post">';
				echo '<input name="dtm" type="hidden" value="',$record->dtm,'">';
				echo '<input class="posit" type="submit" name="edit" value="',i18n("guestbookGS/EDIT_COMMENT"),'"></form>';
				echo '<p><hr class="clrb"></p>';
			}
			echo '<center>'.gsb_paginate($page, $lastpage, $targetpage).'</center>';
			echo '</div>';
			unset($cnt);	 
		}else echo i18n("guestbookGS/XML_FORMAT_FILED");
		unset($nxml);
	}else echo i18n("guestbookGS/XML_READ_FILED");
}
	
function get_gstbook($slug){
	global $i18n;
	global $ravno;
	$conf = gsb_config(PAGE_PATH.GUEST_CONF);	
	i18n_merge('guestbookGS') || i18n_merge('guestbookGS','en_US'); 
	if((string)return_page_slug() == $slug){
		if(file_exists(PAGE_PATH.GUEST_BOOK)){ //Блок вывода модерированных отзывов (conclusion reviews of past moderation)
			$xml = simplexml_load_file(PAGE_PATH.GUEST_BOOK);
			if($xml){
				$axml = array();
				foreach($xml as $arecord){
					$axml[] = $arecord;
				}
				/*usort($naxml,function($a,$b){return $a['dtm']-$b['dtm'];});*/
				
				$xml = ($conf['gsb_sort'] == 'true') ? array_reverse($axml) : $axml;
				$xml_cnt = count($xml);
				$limit = (int)$conf['gsb_item'];
				$targetpage = '/'.$slug.'/?';
				
				$page = (isset($_GET['page'])) ? (int)$_GET['page'] : false;
				$start = ($page) ? ($page - 1) * $limit : 0;
				$lastpage = ceil($xml_cnt/$limit);
				$xml = array_slice($xml, $start, $limit);
				
				echo '<div class="gsb" itemscope itemtype="https://schema.org/Review">'.PHP_EOL;
				foreach($xml as $record){
					if(strtoupper($record->visibility) == "TRUE"){
						$gsbi_rate = '';
						for($gsbi = 1; $gsbi <= 5; $gsbi++){
							if($gsbi <= (int)$record->rating) $gsbi_rate .= '<span class="active"></span>';
							else $gsbi_rate .= "<span></span>";
						}
						echo '<div class="cont">'.PHP_EOL;
						echo '<div id="nme" itemprop="name" style="display:none;">Отзыв от '.$record->username.'</div>'.PHP_EOL;
						echo '<div id="msg" itemprop="reviewBody">'.$record->message.'</div>'.PHP_EOL;
						echo '<div class="atr">'.PHP_EOL;
						echo '<div id="usr" itemprop="author" itemscope itemtype="https://schema.org/Person"><span style="color:unset;" itemprop="name">'.$record->username.'</span></div>'.PHP_EOL;
						if($conf['gsb_date'] == 'true'){
							echo '<div id="dtm">'.date('d-m-Y H:i', (int)$record->dtm).'</div>'.PHP_EOL;
							echo '<meta itemprop="datePublished" content="'.date('Y-m-d', (int)$record->dtm).'"/>'.PHP_EOL;
						}
						if((int)$record->rating > 0){
							echo '<div class="rating-mini" itemprop="reviewRating" itemscope itemtype="http://schema.org/Rating">'.PHP_EOL;
							echo $gsbi_rate.PHP_EOL;
							echo '<meta itemprop="worstRating" content="0">'.PHP_EOL;
							echo '<meta itemprop="ratingValue" content="'.(int)$record->rating.'">'.PHP_EOL;
							echo '<meta itemprop="bestRating" content="5">'.PHP_EOL;
							echo '</div>'.PHP_EOL;
						}
						echo '</div>'.PHP_EOL;
						echo '</div>'.PHP_EOL;
						echo '<span itemprop="itemReviewed" itemscope itemtype="https://schema.org/Organization">'.PHP_EOL;
						echo '<meta itemprop="name" content="'.$_SERVER['HTTP_HOST'].'">';
						echo '</span>'.PHP_EOL;
					}
				}
				echo '<center>'.gsb_paginate($page, $lastpage, $targetpage).'</center>'.PHP_EOL;
				echo '</div>'.PHP_EOL;
			}else echo i18n("guestbookGS/XML_FORMAT_FILED");
			unset($xml);
		}else echo i18n("guestbookGS/XML_READ_FILED");
		
		$captchaResult = isset($_POST['captchaResult']) ? $_POST['captchaResult'] : false;
		if(!empty($_POST['login'])) exit('<p class="gsb_rmsg">Скрытое поле заполнять запрещено!<p>');
		if($captchaResult && is_array($_SESSION["cap_code"])){
			if($captchaResult != $_SESSION["cap_code"][3]){
				unset($_SESSION["cap_code"]);
				echo '<p id="ref" class="gsb_rmsg">',i18n("guestbookGS/CAPTCHA_ERROR"),'<p>';
			}else{
				echo '<p id="ref" class="gsb_rmsg1">',i18n("guestbookGS/SEND"),'<p>';
				$username = (string)trim(strip_tags($_POST['username']));
				$mail = (string)trim(strip_tags($_POST['mail']));
				$message = (string)trim(escapeStr($_POST['message']));
				//$message =. "\n". "IP-адрес отправителя: ".$_SERVER['REMOTE_ADDR']; // IP-адрес отправителя
				$rating = (isset($_POST['rating'])) ? (int)$_POST['rating'] : 0;
				$notif_to = $conf['gsb_to'];
				$notif_subject = 'Вам написали отзыв на '.$_SERVER['HTTP_HOST']. ' от '.$_SERVER['REMOTE_ADDR']; // Тема письма
				$from = 'From: '.$_SERVER['HTTP_HOST'].$conf['gsb_from'];
				if($conf['gsb_send'] == 'true') @mail($notif_to, $notif_subject, $message, $from);
				if(!file_exists(PAGE_PATH.GUEST_BOOK)){  //Создание начальной формы XML (Create primary XML form)
					$dom = new DOMDocument("1.0", "UTF-8");
					$title = $dom -> createElement('title');
					$dom->appendChild($title);
					$dom->save(PAGE_PATH.GUEST_BOOK);
				} 
				$sxml = simplexml_load_file(PAGE_PATH.GUEST_BOOK); // Заполнение XML (Populating XML data)
				$record = $sxml->addChild('record');
				$record->addChild('username', $username);
				$record->addChild('mail', $mail);
				$record->addChild('message', $message);
				$record->addChild('rating', $rating);
				$record->addChild('dtm', time());
				$record->addChild('visibility', "false");
				$sxml->asXML(PAGE_PATH.GUEST_BOOK);
			}
			unset($_SESSION["cap_code"]);
		}else{
			generate_cap_code();
			$cap_code = $_SESSION["cap_code"];
			$gsbi_rati = '';
			for($gsbi = 5; $gsbi >= 1; $gsbi--){
				$gsbi_rati .= '<input type="radio" id="star-'.$gsbi.'" name="rating" value="'.$gsbi.'"><label for="star-'.$gsbi.'" title="Оценка «'.$gsbi.'»"></label>';
			}
			
			if($conf['gsb_date'] == 'false') echo '<style>.gsb .atr{padding-top:10px;} .gsb .rating-mini{margin: -25px 0 0 13px;}</style>';
			echo '<div class="gsb">';
			echo '<form action="'.$slug.'#ref" method="post" class="cont1">';
			echo '<input class="test0" required name="username" type="text" placeholder="',i18n("guestbookGS/YOUR_NAME"),'" maxlength = "30" title=" ',i18n("guestbookGS/ENTER_NAME"),'">';
			echo '<input class="test3" name="mail" type="text" pattern="|^[-0-9A-Za-z_\.]+@[-0-9A-Za-z^\.]+\.[a-z]{2,6}$|i" title="',i18n("guestbookGS/ENTER_EMAIL"),'" placeholder="',i18n("guestbookGS/YOUR_EMAIL"),'" maxlength = "30">';
			echo '<textarea class="test2" name="message"  placeholder=" ',i18n("guestbookGS/YOUR_MSG"),'" maxlength="1000" title="',i18n("guestbookGS/ENTER_MSG"),'"></textarea>';
			echo '<div class="rating-area">'.$gsbi_rati.'</div>';
			echo '<center>'.$cap_code[0].' '.$cap_code[2].' '.$cap_code[1].' '.$ravno.' ';
			echo '<input class="test4" name="captchaResult" type="text" required placeholder="Ответ числом" onKeyPress="cifri()" /></center>';
			echo '<input name="login" style="display:none;" placeholder="Логин"/>';
			echo '<input type="submit" value="Отправить" class="gstbook_send">';
			echo '</form>';
			echo '<div id="ref" class="blank2"></div>';
			echo '<script>function cifri(){if(event.keyCode != 13 && event.keyCode != 45 && event.keyCode < 48 || event.keyCode > 57) event.returnValue=false;}</script>';
			if($conf['nicEdit'] == 'true'){
				echo '<script type="text/javascript" src="/'.NIC_EDIT.'"></script>';
				echo '<script>bkLib.onDomLoaded(function(){nicEditors.allTextAreas({fullPanel:true})});</script>';
			}
			echo '</div>';
		}
		echo '<script>window.addEventListener("load",function(e){e.preventDefault();var o=window.location.hash.slice(1),t=document.getElementById(o);t&&t.scrollIntoView({behavior:"smooth",block:"end"})});</script>';
	}
}

function escapeStr($str){
	$conf = gsb_config(PAGE_PATH.GUEST_CONF);
	$str = ($conf['nicEdit'] == 'false') ? strip_tags($str) : trim($str);
	$str = preg_replace('/&nbsp;/', ' ', $str);
	$str = preg_replace('/(<script[^>]*>.+?<\/script>|<style[^>]*>.+?<\/style>)/s', '', $str);
	return $str;
}

function gsb_paginate($page, $lastpage, $targetpage){
	if($lastpage <= 1) return;
	$prev = $page - 1;
	$next = $page + 1;
	$count = 1;
	$paginate = '<div class="paginate">';
	$paginate .= ($prev == 1) ? '<a href="'.substr($targetpage,0,-1).'">Назад</a>' : (($page > 1) ? '<a href="'.$targetpage.'page='.$prev.'">Назад</a>' : '<span class="disabled">Назад</span>');
	for($cnt = $count; $cnt <= $lastpage; $cnt++){
		if($cnt == $page){
			$paginate .= ($cnt == $page) ? '<span class="current">'.$cnt.'</span>' : '<a href="'.$targetpage.'page='.$cnt.'">'.$cnt.'</a>';
		}else{
			$paginate .= ($cnt != 1) ? '<a href="'.$targetpage.'page='.$cnt.'">'.$cnt.'</a>' : (($page != 0) ? '<a href="'.substr($targetpage,0,-1).'">'.$cnt.'</a>' : '<span class="current">'.$cnt.'</span>');
		}
	}
	$paginate .= ($page < $cnt - 1) ? '<a href="'.$targetpage.'page='.(($next == 1) ? $next + 1 : $next).'">Далее</a>' : '<span class="disabled">Далее</span>';
	$paginate .= '</div>';  
	return $paginate;
}
?>